//+------------------------------------------------------------------+
//|                                             TFColorFunctions.mq4 |
//|                                                         xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+
//#property copyright "xFrienDx"
//#property link      "ffriend@rambler.ru"
#import "TFColor.ex4"

//+------------------------------------------------------------------+
//                                                            |
//+------------------------------------------------------------------+

//      Print       PRINT_DEBUG.
//string sMessage - ,   .
void PrintD(string sMessage);

//       .
//string sName -  .
void SetObjectVisibleOnTF(string sName);

//          .    .
//string sName -  .
//string sType -  ,   .   : WAVE_LINE - , WAVE_NAME -  ,
//FIBO_SCALE - , TARGET -  , NK -  , PIVOT - , ALL -    .
string GetVATSMFObjectName(string sName, string sType);

//           .
//string sName -  .
string Object_Number(string sName);

//      .
//string sName -  .
string Object_Name(string sName);

//      .  1 -    , -1 - , 0 - .   - .
//string sName -  .
int Object_Direction(string sName);

//   (nSide = 1)   (nSide = 2)    .
//string sName -  .
//int nSide -    .
datetime Time_(string sName, int nSide);

//   (nSide = 1)   (nSide = 2)    .
//string sName -  .
//int nSide -    .
double Price_(string sName, int nSide);

//    FIBO, TRENDLINE, TEXT, RECTANGLE
//string sName -  .
//color clColor -  .
string RenameObjectForVATSMF(string sName, color clColor);

//  -: FIBO_IMPULS - , FIBO_NORMAL - , FIBO_CORRECT - , FIBO_TYPE_ERROR -    
//string sName -  .
int IsFiboImpulse(string sName);

//       
//color clColor -      sName
//string sName -  .
void SetObjectColor(string sName, color clColor);

//   ,          
//color clColor -     
int GetShownTFsByColor(color clColor);

//     PERIOD_M1, PERIOD_M5  ..
//int nTimeFrame -   (PERIOD_M1, PERIOD_M5  ..)
color GetColorByTF(int nTimeFrame);

//   
//color clColor -      
int GetTFByColor(color clColor);

//  ,   PERIOD_M1  "M1",  PERIOD_M5  "M5"  ..
//int nTimeFrame -   (PERIOD_M1, PERIOD_M5  ..)
string GetTFName(int nTimeFrame);

//     
//color clColor -       TF
string GetTFNameByColor(color clColor);

//        .
//string sName -   .
color GetColorByTFName(string sName);

//  
//string sName -  .
void MakeFiboImpulse(string sName);

//  
//string sName -  .
void MakeFiboCorrection(string sName);

//   ,        100%.
void MakeFiboNormal(string sName);

//      
//string sName -  .
void ObjectPropertiesForm(string sName);

//      
void ChangeSetingsForm();

//        .
void DeleteObjectsForm();

//    
//string sName -  .
string CreateFibo(string sName, int nPeriod);

//     
//string sName -  .
//string WaveName -  .
//int nPeriod -  .
void CreateWaveName(string sName, string WaveName, int nPeriod);

//     .
bool CloseScriptOnPressedHotKey();

//     .
void ResetHotKeyState();

//   ,        ,       .
//string sName -  .
string GetWaveName(string sName);

//      .
string FontFace();

//          .         ,     ,    .
string AdjustPivot(string sName);

//    (, , )   .
//string sName -  .
//string sType - WAVE_LINE - , NK -  , PIVOT - .
//int nObj -   .
string FindYoungerTFObject(string sName, string sType, int nObj);

//         .
//string sName -  , int nShift -   , -1   , -2      ..
//1   , 2    . 
string FindSameTFWave(string sName, int nShift);

//   c      . nShift       .
//, -2         ,           ,
//1              .
string FindElderTFWave(string sName, int nShift);

//        ,  ()  b(C)
//string sName -  .
void CreateNK(string sName);

//  4      AutoIt3
void Link(string &asProperties[]);

//       .
datetime GetExectTLTime(datetime dtTime, double nPrice, int nDirection);

//            .
double MaxMin(int nDirection, int nPeriod, int i);

//         .
void AdjustTrendLine(string sName);

#import