//+------------------------------------------------------------------+
//|                                                Object_Delete.mq4 |
//|                                       Copyright  2013, xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, xFrienDx"
#property link      "ffriend@rambler.ru"
#include <WinUser32.mqh>   //    "user32.dll"  API Windows XP.
#include <stdlib.mqh>      //     .
#include <TFColor.mqh>
#include <TFColorFunctions.mqh>

#import "user32.dll"
int GetAsyncKeyState  (int button);
int GetCursorPos(int Pos[2]);
#import
//#define VK_LBUTTON  0x01   //   
//#define VK_MENU     0x12	// ALT key 


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int N, lpRect[4], Pos[2], numBarsInGrid,  hWndChart, numVisibleBars, nBarWidth;
   double YCurrent, XCurrent, nVisibleBars;    
   double dMaxPrice, dMinPrice, dOnePixelCost;
   double dWindowWidth, nWindowHeight, dChartScale;
   datetime dtFirstTime;
   int i, j, k, nObjType, nObjectArea, nObjectVisibility, nCurrentTF ;
   string sName, sCurrentObjectName, sObjName, sNum;
   double dPrice1, dPrice2, dBar1, dBar2, dFirstBar, dLastBar, dEvaluatedY;
   int nObjArraySize;
   int anObjType[];
   string asObjName[];
   int anY1[];
   int anY2[];
   int anX1[];
   int anX2[];
   bool bScale1x1State;
  
   hWndChart = WindowHandle(Symbol(), 0);//   .
   GetWindowRect(hWndChart,lpRect);//    .

   nVisibleBars = WindowBarsPerChart();//    .
   dWindowWidth = lpRect[2] - lpRect[0] - 50;//50          .
   numBarsInGrid = MathRound(32 * nVisibleBars / dWindowWidth);//     .            
   dMaxPrice = WindowPriceMax(0);//    .
   dMinPrice = WindowPriceMin(0);//    .
   nWindowHeight = 10000*(dMaxPrice-dMinPrice)*32/numBarsInGrid - 1;//    .

//              
//  .    .   
//   bScale1x1State = GetScale1x1State();
//   if(!bScale1x1State)//    1:1.
//   {
      PostMessageA(hWndChart, WM_COMMAND, 35412, 0);//   1:1.
      Sleep(50);
      dMaxPrice = WindowPriceMax(0);//    .
      dMinPrice = WindowPriceMin(0);//    .
      nWindowHeight = 10000*(dMaxPrice-dMinPrice)*32/numBarsInGrid - 1;//    .
      if(nWindowHeight > 10000)//   
         nWindowHeight = nWindowHeight/100;//     100,    .
      PostMessageA(hWndChart, WM_COMMAND, 35412, 0);//  .
//   }      

   sCurrentObjectName = "";//      .                     
   GetAsyncKeyState(VK_MENU);//    ALT.
   while(GetAsyncKeyState(VK_MENU)!= -32767)//    Alt   .
   {
      Sleep(50);  
      ResetHotKeyState();//   .
      dtFirstTime = iTime(Symbol(), Period(), WindowFirstVisibleBar());//     .
      dMaxPrice = WindowPriceMax(0);//    .
      dMinPrice = WindowPriceMin(0);//    .
      nVisibleBars = WindowBarsPerChart();//    .
      dWindowWidth = lpRect[2] - lpRect[0] - 50;//50          .
      numBarsInGrid = MathRound(32 * nVisibleBars / dWindowWidth);//     .            
      dOnePixelCost = (dMaxPrice - dMinPrice) / nWindowHeight;//   .
      nBarWidth = 32 / numBarsInGrid;//    .

      j=0;
      dFirstBar = WindowFirstVisibleBar();//     .
      dLastBar = WindowFirstVisibleBar()-WindowBarsPerChart();//     .
      nObjArraySize = ObjectsTotal();//    .
      ArrayResize(anObjType, nObjArraySize);
      ArrayResize(asObjName, nObjArraySize);
      ArrayResize(anY1 , nObjArraySize);
      ArrayResize(anY2 , nObjArraySize);
      ArrayResize(anX1 , nObjArraySize);
      ArrayResize(anX2 , nObjArraySize);
      
      N = ObjectsTotal();// .
      for(i=0; i < N; i++)//        .
      {
         sObjName = ObjectName(i);
         sName = GetVATSMFObjectName(sObjName, ALL);//           .
         if(sName == "")
            continue;
         nObjectVisibility = ObjectGet(sName, OBJPROP_TIMEFRAMES);//     .
//Print(nObjectVisibility);
         switch(Period())//     .
         {
         case 1:
            nCurrentTF = 1;
            break;
         case 5:
            nCurrentTF = 2;
            break;
         case 15:
            nCurrentTF = 4;
            break;
         case 30:
            nCurrentTF = 8;
            break;
         case 60:
            nCurrentTF = 16;
            break;
         case 240:
            nCurrentTF = 32;
            break;
         case 1440:
            nCurrentTF = 64;
            break;
         case 10080:
            nCurrentTF = 128;
            break;
         case 43200:
            nCurrentTF = 256;
            break;
         }
         if((nObjectVisibility < nCurrentTF)&&(nObjectVisibility !=0))//     ,
            continue;//      .
         nObjType = ObjectType(sName);//  .
         if((nObjType == OBJ_TREND)||(nObjType == OBJ_FIBO)||(nObjType == OBJ_RECTANGLE))//    ,   ,
         {  
            dPrice1 = ObjectGet(sName, OBJPROP_PRICE1);//        
            dPrice2 = ObjectGet(sName, OBJPROP_PRICE2);
            dBar1 = iBarShift(Symbol(), Period(), ObjectGet(sName, OBJPROP_TIME1));//   .
            dBar2 = iBarShift(Symbol(), Period(), ObjectGet(sName, OBJPROP_TIME2));
            if((dPrice1 == dPrice2)&&(dBar1 == dBar2))
               continue;
         }
         if((nObjType == OBJ_TEXT)||(nObjType == OBJ_ARROW))//      , 
         {
            dPrice1 = ObjectGet(sName, OBJPROP_PRICE1);//        
            dPrice2 = ObjectGet(sName, OBJPROP_PRICE1);
            dBar1 = iBarShift(Symbol(), Period(), ObjectGet(sName, OBJPROP_TIME1));//  .
            dBar2 = iBarShift(Symbol(), Period(), ObjectGet(sName, OBJPROP_TIME1));
         }
//Print(sName + " " + dPrice1 + " " + dPrice2 + " " + dBar1 + " " + dBar2);
         //    (   )    
         if(((dPrice1 > dMinPrice)&&(dPrice1 < dMaxPrice)&&(dBar1 < dFirstBar)&&(dBar1 > dLastBar))
            ||((dPrice2 > dMinPrice)&&(dPrice2 < dMaxPrice)&&(dBar2 < dFirstBar)&&(dBar2 > dLastBar)))
         {
            //    .
            if((nObjType == OBJ_TREND)||(nObjType == OBJ_FIBO))//    ,
               anObjType[j] = 1;//    "1".

            if(nObjType == OBJ_RECTANGLE)// ,
               anObjType[j] = 2;//  "2".

            if((nObjType == OBJ_TEXT)||(nObjType == OBJ_ARROW))//    ,
               anObjType[j] = 3;//  "3".

            asObjName[j] = sName;//    .
            anY1[j] = (dMaxPrice - dPrice1)/dOnePixelCost;//  Y  .
            anY2[j] = (dMaxPrice - dPrice2)/dOnePixelCost;//  Y  .
            anX1[j] = (dFirstBar - dBar1)*nBarWidth;//  X  .
            anX2[j] = (dFirstBar - dBar2)*nBarWidth;//  X  .
//Print("1 ", j, " ",anObjType[j], " ", asObjName[j], ", Y1 = ", anY1[j], ", Y2 = ", anY2[j], ", X1 = ",anX1[j] , ", X2 = ", anX2[j]);               
            j++;//     .
         }
      }

      while((dtFirstTime == iTime(Symbol(), Period(), WindowFirstVisibleBar()))//  ,      ,  
         &&((dMaxPrice == WindowPriceMax())&&(dMinPrice == WindowPriceMin()))
         &&(N == ObjectsTotal()))//   ,     .
      {
         GetCursorPos(Pos);//  .
         Sleep(100);
         //  Y  .
         YCurrent = Pos[1] - lpRect[1] - 4;//      .
         if(Pos[1] > lpRect[1] + nWindowHeight + 5)//      ,
            YCurrent = nWindowHeight;//   Y      .
         if(Pos[1] < lpRect[1]+5)//      ,
            YCurrent = 0;//      .

         //    .
         XCurrent = Pos[0] - lpRect[0]-4;//      .
         if(Pos[0] > lpRect[2]-46)//       ,
            XCurrent = dWindowWidth;//      .
         if(lpRect[0] + 5 > Pos[0])
            XCurrent = 0;//       ,     .
         //        
         sCurrentObjectName = "";
       
         for(i = 0; i < j; i++)//   .
         {
            sCurrentObjectName = "";// ,        .
            nObjectArea = 10;//       ,     .

            if(anObjType[i] == 1)//    .
            {
//Print("   ", i, " ", asObjName[i]);
               if((anX2[i] != anX1[i])&&(anY2[i] != anY1[i]))//    ,    .
               {
                  dEvaluatedY = (XCurrent - anX1[i])*(anY2[i]-anY1[i])/(anX2[i]-anX1[i])+ anY1[i];//  Y, 
                  //       ,      .
                  if(MathAbs(anX2[i] - anX1[i]) - MathAbs(XCurrent - anX1[i]) - MathAbs(XCurrent - anX2[i]) >= 0)
                  //        
                  {
                     if(MathAbs(YCurrent - dEvaluatedY) <  nObjectArea)//       Y
                     //  ,
                     {
                     
                        sCurrentObjectName = asObjName[i];//  ,          .
                        break;
                     }
                  }
               }
               else//,        .
               {
                  if((MathAbs(anY2[i] - anY1[i]) - MathAbs(YCurrent - anY1[i]) - MathAbs(YCurrent - anY2[i]) >= 0)
                  //   Y      
                     &&(MathAbs(XCurrent - anX1[i]) < nObjectArea))//       
                     //  ,
                  {
                     sCurrentObjectName = asObjName[i];//  ,          .
                     break;
                  }
                  if((MathAbs(anX2[i] - anX1[i]) - MathAbs(XCurrent - anX1[i]) - MathAbs(XCurrent - anX2[i]) >= 0)
                  //         
                     &&(MathAbs(YCurrent - anY1[i]) < nObjectArea))//       Y
                     //  ,
                  {
                     sCurrentObjectName = asObjName[i];//  ,          .
                     break;
                  }
               }
            }              

            if(anObjType[i] == 2)// .
            {
//Print(" ", i, " ", asObjName[i]);               
               if((MathAbs(anY2[i] - anY1[i]) - MathAbs(YCurrent - anY1[i]) - MathAbs(anY2[i] - YCurrent) >= 0)//   
                &&(MathAbs(anX2[i] - anX1[i]) - MathAbs(XCurrent - anX1[i]) - MathAbs(anX2[i] - XCurrent) >= 0))// .
               {
                  sCurrentObjectName = asObjName[i];// true -   ,          .
                  break;
               }
            }   
               
            if(anObjType[i] == 3)//    .
            {
//Print("    ", i, " ", asObjName[i]);              
               if((MathAbs(YCurrent - anY2[i]) <   nObjectArea) && (MathAbs(XCurrent - anX1[i]) <= nObjectArea))
               //           .
               {
                  sCurrentObjectName = asObjName[i];// true -   ,          .
                  break;
               }
            }
		   }
		   //        .
         Comment(/*
            "\n  X = ", Pos[0],
            "\n  Y = ", Pos[1],
            "\n    = ", XCurrent,
            "\n   Y = ", YCurrent,
            "\n    = ", lpRect[0],
            "\n    = ", lpRect[2],
            "\n    = ", lpRect[1],
            "\n    = ", lpRect[3],
            "\n  = ", dWindowWidth,
            "\n  = ",nWindowHeight,
            "\n   = ", nVisibleBars,
            "\n    = ", numBarsInGrid,
            "\n  = ", DoubleToStr(dMaxPrice,5),
            "\n  = ", DoubleToStr(dMinPrice,5),
            "\n   = ", j,*/
            "\n   = ", sCurrentObjectName
             );
         if(GetAsyncKeyState(VK_Q) != 0)//   "Q"
            DeleteObjectsForm();//   .
            
         if(GetAsyncKeyState(VK_A) != 0)//   "A"
         {
            if(sCurrentObjectName != "")//    ,
            {
               sNum = Object_Number(sCurrentObjectName);//  .
               if(ObjectFind(WAVE_LINE + " " + sNum) != -1)//E     ,
                  ObjectDelete(WAVE_LINE + " " + sNum);//  .
               if(ObjectFind(WAVE_NAME + " " + sNum) != -1)//E      ,
                  ObjectDelete(WAVE_NAME + " " + sNum);//  .
               if(ObjectFind(NK + " " + sNum) != -1)//E      ,
                  ObjectDelete(NK + " " + sNum);//  .
               if(ObjectFind(FIBO_SCALE + " " + sNum) != -1)//E     ,
                  ObjectDelete(FIBO_SCALE + " " + sNum);//  .
               if(ObjectFind(PIVOT + " " + sNum) != -1)//E     ,
                  ObjectDelete(PIVOT + " " + sNum);//  .
               if(ObjectFind(FZR + " " + sNum) != -1)//E     ,
                  ObjectDelete(FZR + " " + sNum);//  .
            }
         }
         if(GetAsyncKeyState(VK_Z) != 0)//   "Z"
         {
            if(sCurrentObjectName != "")//    ,
               ObjectDelete(sCurrentObjectName);//   .
         }
         if(GetAsyncKeyState(VK_MENU) == -32767)//  ALT ,
         {
            Comment("");//     
            return(0);//   .
         }
      }         
   }
}
//+------------------------------------------------------------------+
//    .
bool GetScale1x1State()
{
   int hWndChart, hWndProperty, hWndChild_1_Level, hWndChild_2_Level, hWndButton, nScaleFix_1x1;
   string sButtonName;

   hWndChart = WindowHandle(Symbol(), 0);//   .
   Sleep(100);
   PostMessageA(hWndChart, WM_COMMAND, 33157, 0);//   .
   Sleep(100);
   hWndProperty = GetLastActivePopup(GetAncestor(hWndChart,2));//    .
   hWndChild_1_Level = GetWindow(hWndProperty,GW_HWNDFIRST|GW_CHILD);//     .
   while (hWndChild_1_Level != 0) // ,      .
   { 
      hWndChild_2_Level = GetWindow(hWndChild_1_Level,GW_HWNDFIRST|GW_CHILD);//     .
      while (hWndChild_2_Level != 0)// ,      .
      {
         sButtonName  = "                        ";//    .
         Sleep(1);
         SendMessageA (hWndChild_2_Level, WM_GETTEXT, 24, sButtonName );//     .
         if(sButtonName == "  1:1")//     -   .
         {
            hWndButton = hWndChild_2_Level;//     ().
            break;
         }
         hWndChild_2_Level = GetWindow(hWndChild_2_Level,GW_HWNDNEXT);//      .
      }
      Sleep(1);
      hWndChild_1_Level = GetWindow(hWndChild_1_Level,GW_HWNDNEXT);//      . 
   }
   nScaleFix_1x1 = SendMessageA(hWndButton, BM_GETCHECK, 0, 0);//   "  1:1"
   //   .
   PostMessageA(hWndProperty, WM_KEYDOWN, VK_ENTER, 0);//   .
//      Print(nScaleFix_1x1);
   return(nScaleFix_1x1);
}

