//+------------------------------------------------------------------+
//|                                                   Object_MN1.mq4 |
//|                                        Copyright 2013, xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+
//
//         troshenkin@bk.ru

#property copyright "Copyright  2013, xFrienDx"
#property link      "ffriend@rambler.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//   .
//       LT (   ,
//         LT+7, LT  
// .        .
//          , 
//    MN1     .   
//        1 .   
//       ""("~").   
//  ,      (LT  ).
//            
// .      .    
//      .     
//           
// (,  1  2,   3,     1,  ..).
//        LT  . 
//    ,       
// (   (   ,   ),
//   ,        
// (  ,  ,  ,    ).
//       ,   
//  LT     .    
//       (  
// /       (  , 
// ,  ,    )).
//     ,    LT 
//    .    (  LT) 
//  .        .
//+------------------------------------------------------------------+

#include <TFColor.mqh>
#include <TFColorFunctions.mqh>
#include <WinUser32.mqh>
#import "user32.dll"
int GetAsyncKeyState  (int button);
#import

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int i, n, k, hwnd, nMainRealTF, nElderRealTF, nStart, nEnd;
   string sName;
   color clMainColor;
   string asObjectName[];

   clMainColor = GetColorByTFName("MN1");//  MN1.
   ResetHotKeyState();//  "" .
   n = ObjectsTotal();// .
   hwnd = WindowHandle(Symbol(), 0);//   .
   PostMessageA(hwnd, WM_COMMAND, 33257, 0);// WinAPI        .
   k = 0;
   ArrayResize(asObjectName, n+1);//  .
   for(i = 0; i < n; i++)//   .
      asObjectName[i] = ObjectName(i);
   while (n == ObjectsTotal())//       .
   {  
      if(GetAsyncKeyState(VK_MENU) == 0)//   LT         "".
      {
         PostMessageA(hwnd, WM_COMMAND, 33234, 0);
         return(0);
      }
      if(GetAsyncKeyState(VK_OEM_3) == -32767)
         clMainColor = GetColorByTFName("M1");
      if(CloseScriptOnPressedHotKey())//  "" ,         .
         return(0);
      if(GetAsyncKeyState(VK_RBUTTON) == -32767)//    ,     .
      {
         int N = MathMod(k,4);
         switch(N)
         {
         case 0:
            PostMessageA(hwnd, WM_COMMAND, 35464, 0);//  .
            k++;
            break;
         case 1:
            PostMessageA(hwnd, WM_COMMAND, 33247, 0);//.
            k++;
            break;
         case 2:
            PostMessageA(hwnd, WM_COMMAND, 33237, 0);//.
            k++;
            break;
         case 3:
            PostMessageA(hwnd, WM_COMMAND, 33257, 0);// .
            k++;
            break;
         }
      }   
      Sleep(10);
   }
   for(i = 0; i < ObjectsTotal(); i++)//     ,        1.
   {
      if(ObjectName(i) != asObjectName[i])//       ,
      {
         sName = ObjectName(i);//      .
         break;
      }
   }
   SetObjectColor(sName, clMainColor);//         ,     .
   sName = RenameObjectForVATSMF(sName, clMainColor);// ,       .
   nMainRealTF = GetTFByColor(clMainColor);
   k = ArrayBsearch(REAL_TF, nMainRealTF,WHOLE_ARRAY,0,MODE_ASCEND);//            .
   
   if(nMainRealTF == 15)//    15,     1,   30  .
      nElderRealTF = 60;
   else if(nMainRealTF == 43200)//    N1,    12*N1,       N1 . 
      nElderRealTF = 518400;
   else
      nElderRealTF = REAL_TF[k+1];//      .
   
   nStart = ArrayBsearch(ALL_TF, nMainRealTF,WHOLE_ARRAY,0,MODE_ASCEND);//      (   ),       .
   if(nMainRealTF == 43200)//       N1,         ,         .
      nEnd = ArraySize(ALL_TF);
   else
      nEnd = ArrayBsearch(ALL_TF, nElderRealTF,WHOLE_ARRAY,0,MODE_ASCEND);//           .
   
   k = nStart;         

   while(GetAsyncKeyState(VK_MENU)!= 0)//   ALT,       .
   {
      if(CloseScriptOnPressedHotKey())//  "" ,        .
      {
         ObjectDelete(sName);//  ,      .
         return(0);
      }
      Sleep(10);
      if(GetAsyncKeyState(VK_LBUTTON)== -32767)//    ,          
      {
         k++;
         while((GetColorByTF(ALL_TF[k]) == 1)&&(ALL_TF[k] !=0))//    1 (      ),      .     ,   .
            k++;
         if(k >= nEnd)//       ,         .
            k = nStart;
         SetObjectColor(sName, GetColorByTF(ALL_TF[k]));
      }
   }

   if((ObjectType(sName) == OBJ_TREND)||(ObjectType(sName) == OBJ_FIBO))//        ALT,    " "  " "      .
      ObjectPropertiesForm(sName);

   return(0);
}
//+------------------------------------------------------------------+

