//+------------------------------------------------------------------+
//|                                            Object_Visibility.mq4 |
//|                                        Copyright 2013, xFrienDx |
//|                                               ffriend@rambler.ru |
//+------------------------------------------------------------------+

#property copyright "Copyright  2013, xFrienDx"
#property link      "ffriend@rambler.ru"
//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//    ,      
// .      :
// 1)   (   )  TFColor.mqh;
// 2)        ;
// 3)           .
//+------------------------------------------------------------------+

#include <TFColor.mqh>
#include <TFColorFunctions.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int i;
   string name;

   if(ObjectFind("ObjectsViemOneTF") == -1)
   {
      ObjectCreate("ObjectsViemOneTF", OBJ_LABEL,0,0,0);
      ObjectSet("ObjectsViemOneTF", OBJPROP_CORNER, 2);
      ObjectSet("ObjectsViemOneTF", OBJPROP_XDISTANCE, 10);      
      ObjectSet("ObjectsViemOneTF", OBJPROP_YDISTANCE, 10);
      ObjectSet("ObjectsViemOneTF", OBJPROP_COLOR, Red);
      ObjectSetText("ObjectsViemOneTF", "        !", 10, "Times New Roman", Red);      
      
      for(i=0; i < ObjectsTotal(); i++)
      {
         name = ObjectName(i);
         if (GetVATSMFObjectName(name, ALL) == "" )
            continue;

         SetObjectVisibleOnTF(name);
      }
   }
   else
   {
      if(ObjectGet("ObjectsViemOneTF", OBJPROP_COLOR) == Red)
      {
         ObjectSetText("ObjectsViemOneTF", "       1  !", 10, "Times New Roman", OrangeRed);

         for(i=0; i < ObjectsTotal(); i++)
         {
            name = ObjectName(i);
            if (GetVATSMFObjectName(name, ALL) == "" )
               continue;

            SetObjectVisibleOnTF(name);
         }
      }
      else
      {
         ObjectDelete("ObjectsViemOneTF");
         for(i=0; i < ObjectsTotal(); i++)
         {
            name = ObjectName(i);
            if (GetVATSMFObjectName(name, ALL) == "" )
               continue;
            SetObjectVisibleOnTF(name);
         }   
      }
   }
   return(0);
}
//+------------------------------------------------------------------+